'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var globby = _interopDefault(require('globby'));
var docgen = _interopDefault(require('react-docgen-typescript'));

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

const getParser = (config, options, parserOptions) => {
  if (config) {
    return docgen.withCustomConfig(config, parserOptions).parse;
  } else if (options) {
    return docgen.withCompilerOptions(options, parserOptions).parse;
  }

  return docgen.withDefaultConfig(parserOptions).parse;
};

function plugin(context, {
  src,
  global = false,
  route,
  tsConfig,
  compilerOptions,
  parserOptions
}) {
  return {
    name: 'docusaurus-plugin-react-docgen-typescript',

    async loadContent() {
      return getParser(tsConfig, compilerOptions, parserOptions)(await globby(src));
    },

    async contentLoaded({
      content,
      actions
    }) {
      const {
        createData,
        setGlobalData,
        addRoute
      } = actions;

      if (global) {
        console.warn('Using global data can potentially slow down your entire app. Use with care ❤️');
        setGlobalData(content);
      } else {
        addRoute(_objectSpread2(_objectSpread2({}, route), {}, {
          modules: {
            docgen: await createData('docgen.json', JSON.stringify(content))
          }
        }));
      }
    }

  };
}

exports.default = plugin;
//# sourceMappingURL=index.js.map
